VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "Aircar Assembly Demo"
   ClientHeight    =   6960
   ClientLeft      =   1140
   ClientTop       =   1425
   ClientWidth     =   8625
   Height          =   7335
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   6960
   ScaleWidth      =   8625
   Top             =   1110
   Width           =   8745
   Begin VB.CommandButton Command3 
      Caption         =   "Stop"
      Height          =   375
      Left            =   3240
      TabIndex        =   11
      Top             =   6480
      Width           =   2295
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Animate"
      Height          =   375
      Left            =   120
      TabIndex        =   10
      Top             =   6480
      Width           =   2295
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Reset"
      Height          =   375
      Left            =   6240
      TabIndex        =   9
      Top             =   6480
      Width           =   2295
   End
   Begin VB.CheckBox pit 
      Caption         =   "Cockpit"
      Height          =   375
      Left            =   120
      TabIndex        =   8
      Top             =   6000
      Value           =   1  'Checked
      Width           =   1215
   End
   Begin VB.CheckBox tail 
      Caption         =   "Tail"
      Height          =   375
      Left            =   7680
      TabIndex        =   7
      Top             =   6000
      Value           =   1  'Checked
      Width           =   615
   End
   Begin VB.CheckBox fins 
      Caption         =   "Fins"
      Height          =   375
      Left            =   6840
      TabIndex        =   6
      Top             =   6000
      Value           =   1  'Checked
      Width           =   735
   End
   Begin VB.CheckBox engine4 
      Caption         =   "Engine 4"
      Height          =   375
      Left            =   5640
      TabIndex        =   5
      Top             =   6000
      Value           =   1  'Checked
      Width           =   1095
   End
   Begin VB.CheckBox engine3 
      Caption         =   "Engine 3"
      Height          =   375
      Left            =   4560
      TabIndex        =   4
      Top             =   6000
      Value           =   1  'Checked
      Width           =   975
   End
   Begin VB.CheckBox engine2 
      Caption         =   "Engine 2"
      Height          =   375
      Left            =   3480
      TabIndex        =   3
      Top             =   6000
      Value           =   1  'Checked
      Width           =   1095
   End
   Begin VB.CheckBox engine1 
      Caption         =   "Engine 1"
      Height          =   375
      Left            =   2280
      TabIndex        =   2
      Top             =   6000
      Value           =   1  'Checked
      Width           =   1095
   End
   Begin VB.CheckBox Frame 
      Caption         =   "Frame"
      Height          =   375
      Left            =   1320
      TabIndex        =   1
      Top             =   6000
      Value           =   1  'Checked
      Width           =   975
   End
   Begin TgsVisual3SpaceLibCtl.V3Space V3Space1 
      Height          =   6015
      Left            =   0
      TabIndex        =   0
      Top             =   -120
      Width           =   8655
      _Version        =   131072
      _ExtentX        =   15266
      _ExtentY        =   10610
      _StockProps     =   0
      decorationOn    =   0   'False
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Dim theRoot As SoSeparator
Dim airTran As SoTransform

Dim frameGeom As Object
Dim t1Geom As Object
Dim t2Geom As Object
Dim t3Geom As Object
Dim t4Geom As Object
Dim finGeom As Object
Dim tailGeom As Object
Dim pitGeom As Object

Dim geomSensor As SoTimerSensor
Dim geomSensorCB As SoSensorCB

Dim waitSensor As SoAlarmSensor
Dim waitSensorCB As SoSensorCB












Private Sub Check1_Click()

End Sub

Private Sub Check4_Click()

End Sub

Private Sub Check2_Click()

End Sub

Private Sub Command1_Click()
    On Error Resume Next
        
    If geomSensor.isScheduled() Then
       Call geomSensor.unschedule
    End If

    If waitSensor.isScheduled() Then
        Call waitSensor.unschedule
    End If
        
        
    Dim t As SoTransform
    
    Set t = frameGeom.getChild(0)
    Call t.translation.setValue(0, 0, 0)
      
    Set t = t1Geom.getChild(0)
    Call t.translation.setValue(0, 0, 0)
    Set t = t2Geom.getChild(0)
    Call t.translation.setValue(0, 0, 0)
    Set t = t3Geom.getChild(0)
    Call t.translation.setValue(0, 0, 0)
    Set t = t4Geom.getChild(0)
    Call t.translation.setValue(0, 0, 0)
    Set t = finGeom.getChild(0)
    Call t.translation.setValue(0, 0, 0)
    Set t = pitGeom.getChild(0)
    Call t.translation.setValue(0, 0, 0)
    Set t = tailGeom.getChild(0)
    Call t.translation.setValue(0, 0, 0)

End Sub

Private Sub Command2_Click()
    
    If geomSensor.isScheduled() Then
        Exit Sub
    End If

    If waitSensor.isScheduled() Then
        Call waitSensor.unschedule
        Dim tx As SbTime
        Set tx = New SbTime
        Call tx.setValue(0)
        Call waitSensor.setTimeFromNow(tx)
        Call waitSensor.schedule
        Set tx = Nothing
    Else
        Call geomSensor.schedule
    End If
    

End Sub


Private Sub Command3_Click()
    On Error Resume Next
       
    If geomSensor.isScheduled() Then
       Call geomSensor.unschedule
    End If

    If waitSensor.isScheduled() Then
        Call waitSensor.unschedule
    End If

End Sub

Private Sub Form_Initialize()

    On Error Resume Next
    Set theRoot = V3Space1.CreateIDispatchObject("SoSeparator")
    Set airTran = V3Space1.CreateIDispatchObject("SoTransform")
    Call theRoot.addChild(airTran)
    
    'Load the Frame
    Set frameGeom = LoadGeom("\examples\data\frame.iv")
    Call theRoot.addChild(frameGeom)
    
    'Load the engine 1
    Set t1Geom = LoadGeom("\examples\data\t1.iv")
    Call theRoot.addChild(t1Geom)
    
    'Load the engine 2
    Set t2Geom = LoadGeom("\examples\data\t2.iv")
    Call theRoot.addChild(t2Geom)
    
    'Load the engine 3
    Set t3Geom = LoadGeom("\examples\data\t3.iv")
    Call theRoot.addChild(t3Geom)
    
    'Load the engine 4
    Set t4Geom = LoadGeom("\examples\data\t4.iv")
    Call theRoot.addChild(t4Geom)
    
    'Load the fins
    Set finGeom = LoadGeom("\examples\data\fins.iv")
    Call theRoot.addChild(finGeom)
    
    'Load the cockpit
    Set pitGeom = LoadGeom("\examples\data\pit.iv")
    Call theRoot.addChild(pitGeom)
    
    'Load the tail
    Set tailGeom = LoadGeom("\examples\data\tail.iv")
    Call theRoot.addChild(tailGeom)
    
    'Set up the timer sensor to drive the animation
    Set geomSensor = New SoTimerSensor
    Set geomSensorCB = New SoSensorCB
    geomSensorCB.sensorType = 2 'timerSensor
    Set geomSensorCB.userDataObject = Nothing
    
    Dim idisp As Object
    Set idisp = V3Space1.GetIDispatch
    
    Dim tx As SbTime
    Set tx = New SbTime
    Call tx.setValue(1 / 60)
    Call geomSensor.setInterval(tx)     'scheduled every 1/60 of a sec
    Call geomSensor.setFunction(idisp, geomSensorCB)
           
           
    'set up the waitSensor
    Set waitSensor = New SoAlarmSensor
    Set waitSensorCB = New SoSensorCB
    waitSensorCB.sensorType = 1 'alarmSensor

    Call waitSensor.setFunction(idisp, waitSensorCB)

    Call V3Space1.setSceneRoot(theRoot)
    Call airTran.rotation.setValueQuaternion(0, 1, 1, 0)
    Call airTran.translation.setValue(0, 0, -10)
        
    
    Call tx.setValue(5)
    Call waitSensor.setTimeFromNow(tx)
    Call waitSensor.schedule
    
cleanup:

    Set idisp = Nothing
    Set tx = Nothing
    Set t = Nothing


End Sub

Public Function LoadGeom(geomName As String) As Object


Dim g As SoSeparator
Set g = New SoSeparator
Dim t As SoTransform
Set t = New SoTransform
Call g.addChild(t)

Dim myInput As SoInput
Set myInput = V3Space1.CreateIDispatchObject("SoInput")
Dim idisp As Object
Set idisp = V3Space1.GetIDispatch()

Dim result As Object

Set result = myInput.readAllUrl(V3Space1.getRegistryDataPath() + geomName, idisp)

Call g.addChild(result)

Set LoadGeom = g

Set idisp = Nothing
Set myInput = Nothing
Set result = Nothing

End Function

Private Sub Form_Terminate()
        
    If geomSensor.isScheduled() Then
       Call geomSensor.unschedule
    End If

    If waitSensor.isScheduled() Then
        Call waitSensor.unschedule
    End If

    Set theRoot = Nothing
    Set airTran = Nothing

    Set frameGeom = Nothing
    Set t1Geom = Nothing
    Set t2Geom = Nothing
    Set t3Geom = Nothing
    Set t4Geom = Nothing
    Set finGeom = Nothing
    Set tailGeom = Nothing
    Set pitGeom = Nothing

    Set geomSensor = Nothing
    Set geomSensorCB = Nothing
End Sub

Private Sub V3Space1_AlarmSensor(ByVal sensorCB As Object, ByVal sensor As Object)
        
    On Error Resume Next
        
    Dim t As SoTransform
    
    If (Frame.Value = 1) Then
        Set t = frameGeom.getChild(0)
        Call t.translation.setValue(10, 0, 0)
    End If
      
    If (engine1.Value = 1) Then
        Set t = t1Geom.getChild(0)
        Call t.translation.setValue(-6, 0, 3)
    End If
    If (engine2.Value = 1) Then
        Set t = t2Geom.getChild(0)
        Call t.translation.setValue(-6, 0, -3)
    End If
    If (engine3.Value = 1) Then
        Set t = t3Geom.getChild(0)
        Call t.translation.setValue(6, 0, -3)
    End If
    
    If (engine4.Value = 1) Then
        Set t = t4Geom.getChild(0)
        Call t.translation.setValue(6, 0, 3)
    End If
    
    If fins.Value = 1 Then
        Set t = finGeom.getChild(0)
        Call t.translation.setValue(-6, 0, 0)
    End If
    
    If pit.Value = 1 Then
        Set t = pitGeom.getChild(0)
        Call t.translation.setValue(0, 0, -6)
    End If
    
    If tail.Value = 1 Then
        Set t = tailGeom.getChild(0)
        Call t.translation.setValue(0, 0, 6)
    End If
        
    Call geomSensor.schedule

    Set sensorCB = Nothing
    Set sensor = Nothing
End Sub

Private Sub V3Space1_TimerSensor(ByVal userData As Object, ByVal sensor As Object)
    
    On Error Resume Next
    
    Dim x As Single
    Dim Y As Single
    Dim Z As Single
    Dim stopFlag As Boolean
    
    stopFlag = True
    
    Dim t As SoTransform
    
    If Frame.Value = 1 Then
        Set t = frameGeom.getChild(0)
        Call t.translation.getValue(x, Y, Z)
        
        x = x - 0.1
        If (x <= 0#) Then
          x = 0
        Else
          stopFlag = False
        End If
        Call t.translation.setValue(x, Y, Z)
    End If
    
    't1Geom
    If engine1.Value = 1 Then
        Set t = Nothing
        Set t = t1Geom.getChild(o)
        Call t.translation.getValue(x, Y, Z)
        
        x = x + 0.05
        If (x >= 0) Then
           x = 0
        Else
           stopFlag = False
        End If
        Z = Z - 0.05
        If Z <= 0 Then
          Z = 0
        Else
          stopFlag = False
        End If
        Call t.translation.setValue(x, Y, Z)
    End If
    
    't2Geom
    If engine2.Value = 1 Then
        Set t = Nothing
        Set t = t2Geom.getChild(0)
        Call t.translation.getValue(x, Y, Z)
        x = x + 0.05
        If (x >= 0) Then
           x = 0
        Else
            stopFlag = False
        End If
        Z = Z + 0.05
        If Z >= 0 Then
           Z = 0
        Else
            stopFlag = False
        End If
        Call t.translation.setValue(x, Y, Z)
    End If
        
    't3Geom
    If engine3.Value = 1 Then
        Set t = Nothing
        Set t = t3Geom.getChild(0)
        Call t.translation.getValue(x, Y, Z)
        x = x - 0.05
        If (x <= 0) Then
           x = 0
        Else
            stopFlag = False
        End If
        Z = Z + 0.05
        If Z >= 0 Then
           Z = 0
        Else
            stopFlag = False
        End If
        Call t.translation.setValue(x, Y, Z)
    End If
    
    't4Geom
    If engine4.Value = 1 Then
        Set t = Nothing
        Set t = t4Geom.getChild(0)
        Call t.translation.getValue(x, Y, Z)
        x = x - 0.05
        If (x <= 0) Then
           x = 0
        Else
            stopFlag = False
        End If
        Z = Z - 0.05
        If Z <= 0 Then
           Z = 0
        Else
            stopFlag = False
        End If
        Call t.translation.setValue(x, Y, Z)
    End If
    
    'finGeom
    If fins.Value = 1 Then
        Set t = Nothing
        Set t = finGeom.getChild(0)
        Call t.translation.getValue(x, Y, Z)
        x = x + 0.05
        If (x >= 0) Then
           x = 0
        Else
            stopFlag = False
        End If
        Call t.translation.setValue(x, Y, Z)
    End If
    
    'tailGeom
    If tail.Value = 1 Then
        Set t = Nothing
        Set t = tailGeom.getChild(0)
        Call t.translation.getValue(x, Y, Z)
        Z = Z - 0.05
        If (Z <= 0) Then
           Z = 0
        Else
            stopFlag = False
        End If
        Call t.translation.setValue(x, Y, Z)
    End If
    
    'pitGeom
    If pit.Value = 1 Then
        Set t = Nothing
        Set t = pitGeom.getChild(0)
        Call t.translation.getValue(x, Y, Z)
        Z = Z + 0.05
        If (Z >= 0) Then
           Z = 0
        Else
            stopFlag = False
        End If
        Call t.translation.setValue(x, Y, Z)
    End If
            
    ''''''
    If stopFlag Then
        Call geomSensor.unschedule
        Dim tx As SbTime
        Set tx = New SbTime
        Call tx.setValue(5)
        Call waitSensor.setTimeFromNow(tx)
        Call waitSensor.schedule
        Set tx = Nothing
    End If

cleanup:
    'Call t.Release
    Set t = Nothing
    Set userData = Nothing
    Set sensor = Nothing
    
End Sub

